## etlcpp 20.42.2+dfsg

=== CMakeLists.txt ===
#######################################################################
# The Embedded Template Library (https://www.etlcpp.com/)
#######################################################################
cmake_minimum_required(VERSION 3.10)

include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/helpers.cmake)

set(MSG_PREFIX "etl |")
etl_determine_version_with_git(${GIT_DIR_LOOKUP_POLICY})
if(NOT ETL_VERSION)
    etl_determine_version_with_file("version.txt")
endif()

project(etl VERSION ${ETL_VERSION} LANGUAGES CXX)

option(BUILD_TESTS "Build unit tests" OFF)
option(NO_STL "No STL" OFF)
# There is a bug on old gcc versions for some targets that causes all system headers
# to be implicitly wrapped with 'extern "C"'
# Users can add set(NO_SYSTEM_INCLUDE ON) to their top level CMakeLists.txt to work around this.
option(NO_SYSTEM_INCLUDE "Do not include with -isystem" OFF)
if (NO_SYSTEM_INCLUDE)
    set(INCLUDE_SPECIFIER "")
else()
    set(INCLUDE_SPECIFIER "SYSTEM")
endif()

add_library(${PROJECT_NAME} INTERFACE)
# This allows users which use the add_subdirectory or FetchContent
# to use the same target as users which use find_package
add_library(etl::etl ALIAS ${PROJECT_NAME})

include(GNUInstallDirs)

target_include_directories(${PROJECT_NAME} ${INCLUDE_SPECIFIER} INTERFACE
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
        )

target_link_libraries(${PROJECT_NAME} INTERFACE)

# only install if top level project
if(${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME})
    # Steps here based on excellent guide: https://dominikberner.ch/cmake-interface-lib/
    # Which also details all steps
    include(CMakePackageConfigHelpers)
    install(TARGETS ${PROJECT_NAME}
        EXPORT ${PROJECT_NAME}Targets
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    )
    if(ETL_VERSION)
        # Generate the package configuration files using CMake provided macros
        if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.14)
            # Generate the package configuration files using CMake provided macros
            write_basic_package_version_file(
                "${PROJECT_NAME}ConfigVersion.cmake"
                COMPATIBILITY SameMajorVersion
                ARCH_INDEPENDENT
            )
        else()
            # This is needed for CMake < 3.14
            # because the ARCH_INDEPENDENT option is not available
            # in CMake < 3.14
            # See https://cmake.org/cmake/help/latest/module/CMakePackageConfigHelpers.html
            # for more information
            write_basic_package_version_file(
                "${PROJECT_NAME}ConfigVersion.cmake"
                COMPATIBILITY SameMajorVersion
            )
        endif()
    endif()
    configure_package_config_file(
        "${PROJECT_SOURCE_DIR}/cmake/${PROJECT_NAME}Config.cmake.in"
        "${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
        INSTALL_DESTINATION
        ${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME}/cmake)

    # Install target file, then package configuration files, and finally the headers
    install(EXPORT ${PROJECT_NAME}Targets
        FILE ${PROJECT_NAME}Targets.cmake
        NAMESPACE ${PROJECT_NAME}::
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME}/cmake)
    install(FILES "${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
        "${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME}/cmake)
    install(DIRECTORY ${PROJECT_SOURCE_DIR}/include/etl DESTINATION include)

endif()

if (BUILD_TESTS)
    enable_testing()
    add_subdirectory(test)
endif()

=== test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(etl_unit_tests LANGUAGES CXX)

#include(FetchContent)
#FetchContent_Declare(
#  googletest
#  URL https://github.com/google/googletest/archive/refs/heads/main.zip
#)

#set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
#FetchContent_MakeAvailable(googletest)

add_executable(etl_tests
	main.cpp
	murmurhash3.cpp
	test_algorithm.cpp
	test_alignment.cpp
	test_array.cpp
	test_array_view.cpp
	test_array_wrapper.cpp
	test_atomic.cpp
	test_base64_RFC2152_decoder.cpp
	test_base64_RFC2152_encoder.cpp
	test_base64_RFC3501_decoder.cpp
	test_base64_RFC3501_encoder.cpp
	test_base64_RFC4648_decoder_with_no_padding.cpp
	test_base64_RFC4648_decoder_with_padding.cpp
	test_base64_RFC4648_encoder_with_no_padding.cpp
	test_base64_RFC4648_encoder_with_padding.cpp
	test_base64_RFC4648_URL_decoder_with_no_padding.cpp
	test_base64_RFC4648_URL_decoder_with_padding.cpp
	test_base64_RFC4648_URL_encoder_with_no_padding.cpp
	test_base64_RFC4648_URL_encoder_with_padding.cpp
	test_binary.cpp
	test_bip_buffer_spsc_atomic.cpp
	test_bit.cpp
	test_bitset_legacy.cpp
	test_bitset_new_comparisons.cpp
	test_bitset_new_default_element_type.cpp
	test_bitset_new_explicit_single_element_type.cpp
	test_bitset_new_ext_default_element_type.cpp
	test_bitset_new_ext_explicit_single_element_type.cpp
	test_bit_stream.cpp
	test_bit_stream_reader_big_endian.cpp
	test_bit_stream_reader_little_endian.cpp
	test_bit_stream_writer_big_endian.cpp
	test_bit_stream_writer_little_endian.cpp
	test_bloom_filter.cpp
	test_bresenham_line.cpp
	test_bsd_checksum.cpp
	test_buffer_descriptors.cpp
	test_byte.cpp
	test_byte_stream.cpp
	test_callback_service.cpp
	test_callback_timer.cpp
	test_callback_timer_atomic.cpp
	test_callback_timer_deferred_locked.cpp
	test_callback_timer_interrupt.cpp
	test_callback_timer_locked.cpp
	test_const_map.cpp
	test_const_map_constexpr.cpp
	test_const_multimap.cpp
	test_const_multimap_constexpr.cpp
	test_char_traits.cpp
	test_checksum.cpp
	test_chrono_clocks.cpp
	test_chrono_day.cpp
	test_chrono_duration.cpp
	test_chrono_hh_mm_ss.cpp
	test_chrono_literals.cpp
	test_chrono_month.cpp
	test_chrono_month_day.cpp
	test_chrono_month_day_last.cpp
	test_chrono_month_weekday.cpp
	test_chrono_month_weekday_last.cpp
	test_chrono_operators.cpp
	test_chrono_time_point.cpp
	test_chrono_weekday.cpp
	test_chrono_weekday_indexed.cpp
	test_chrono_weekday_last.cpp
	test_chrono_year.cpp
	test_chrono_year_month.cpp
	test_chrono_year_month_day.cpp
	test_chrono_year_month_day_last.cpp
	test_chrono_year_month_weekday.cpp
	test_chrono_year_month_weekday_last.cpp
	test_circular_buffer.cpp
	test_circular_buffer_external_buffer.cpp
	test_circular_iterator.cpp
	test_closure.cpp
	test_closure_constexpr.cpp
	test_compare.cpp
	test_constant.cpp
	test_container.cpp
	test_correlation.cpp
	test_covariance.cpp
	test_crc1.cpp
	test_crc16.cpp
	test_crc16_a.cpp
	test_crc16_arc.cpp
	test_crc16_aug_ccitt.cpp
	test_crc16_buypass.cpp
	test_crc16_ccitt.cpp
	test_crc16_cdma2000.cpp
	test_crc16_dds110.cpp
	test_crc16_dectr.cpp
	test_crc16_dectx.cpp
	test_crc16_dnp.cpp
	test_crc16_en13757.cpp
	test_crc16_genibus.cpp
	test_crc16_kermit.cpp
	test_crc16_m17.cpp
	test_crc16_maxim.cpp
	test_crc16_mcrf4xx.cpp
	test_crc16_modbus.cpp
	test_crc16_opensafety_a.cpp
	test_crc16_opensafety_b.cpp
	test_crc16_profibus.cpp
	test_crc16_riello.cpp
	test_crc16_t10dif.cpp
	test_crc16_teledisk.cpp
	test_crc16_tms37157.cpp
	test_crc16_usb.cpp
	test_crc16_x25.cpp
	test_crc16_xmodem.cpp
	test_crc32.cpp
	test_crc32_bzip2.cpp
	test_crc32_c.cpp
	test_crc32_d.cpp
	test_crc32_jamcrc.cpp
	test_crc32_mpeg2.cpp
	test_crc32_posix.cpp
	test_crc32_q.cpp
	test_crc32_xfer.cpp
	test_crc64_ecma.cpp
	test_crc64_iso.cpp
	test_crc8_ccitt.cpp
	test_crc8_cdma2000.cpp
	test_crc8_darc.cpp
	test_crc8_dvbs2.cpp
	test_crc8_ebu.cpp
	test_crc8_icode.cpp
	test_crc8_itu.cpp
	test_crc8_j1850.cpp
	test_crc8_j1850_zero.cpp
	test_crc8_maxim.cpp
	test_crc8_nrsc5.cpp
	test_crc8_opensafety.cpp
	test_crc8_rohc.cpp
	test_crc8_wcdma.cpp
	test_crc8_nrsc5.cpp
	test_cyclic_value.cpp
	test_debounce.cpp
	test_delegate.cpp
	test_delegate_cpp03.cpp
	test_delegate_service.cpp
	test_delegate_service_compile_time.cpp
	test_delegate_service_cpp03.cpp
	test_deque.cpp
	test_endian.cpp
	test_enum_type.cpp
	test_error_handler.cpp
	test_etl_traits.cpp
	test_exception.cpp
	test_expected.cpp
	test_fixed_iterator.cpp
	test_fixed_sized_memory_block_allocator.cpp
	test_flags.cpp
	test_flat_map.cpp
	test_flat_multimap.cpp
	test_flat_multiset.cpp
	test_flat_set.cpp
	test_fnv_1.cpp
	test_format_spec.cpp
	test_forward_list.cpp
	test_forward_list_shared_pool.cpp
	test_fsm.cpp
	test_function.cpp
	test_functional.cpp
	test_function_traits.cpp
	test_gamma.cpp
	test_hash.cpp
	test_hfsm.cpp
	test_hfsm_recurse_to_inner_state_on_start.cpp
	test_histogram.cpp
	test_index_of_type.cpp
	test_indirect_vector.cpp
	test_indirect_vector_external_buffer.cpp
	test_instance_count.cpp
	test_integral_limits.cpp
	test_intrusive_forward_list.cpp
	test_intrusive_links.cpp
	test_intrusive_list.cpp
	test_intrusive_queue.cpp
	test_intrusive_stack.cpp
	test_invert.cpp
	test_io_port.cpp
	test_iterator.cpp
	test_jenkins.cpp
	test_largest.cpp
	test_limiter.cpp
	test_limits.cpp
	test_list.cpp
	test_list_shared_pool.cpp
	test_macros.cpp
	test_make_string.cpp
	test_map.cpp
	test_math.cpp
	test_math_functions.cpp
	test_mean.cpp
	test_memory.cpp
	test_mem_cast.cpp
	test_mem_cast_ptr.cpp
	test_message.cpp
	test_message_broker.cpp
	test_message_bus.cpp
	test_message_packet.cpp
	test_message_router.cpp
	test_message_router_registry.cpp
	test_message_timer.cpp
	test_message_timer_atomic.cpp
	test_message_timer_interrupt.cpp
	test_message_timer_locked.cpp
	test_multimap.cpp
	test_multiset.cpp
	test_multi_array.cpp
	test_multi_range.cpp
	test_multi_span.cpp
	test_multi_vector.cpp
	test_murmur3.cpp
	test_nth_type.cpp
	test_numeric.cpp
	test_observer.cpp
	test_optional.cpp
	test_overload.cpp
	test_packet.cpp
	test_parameter_pack.cpp
	test_parameter_type.cpp
	test_parity_checksum.cpp
	test_pearson.cpp
	test_poly_span_dynamic_extent.cpp
	test_poly_span_fixed_extent.cpp
	test_pool.cpp
	test_pool_external_buffer.cpp
	test_priority_queue.cpp
	test_pseudo_moving_average.cpp
	test_quantize.cpp
	test_queue.cpp
	test_queue_lockable.cpp
	test_queue_lockable_small.cpp
	test_queue_memory_model_small.cpp
	test_queue_mpmc_mutex.cpp
	test_queue_mpmc_mutex_small.cpp
	test_queue_spsc_atomic.cpp
	test_queue_spsc_atomic_small.cpp
	test_queue_spsc_isr.cpp
	test_queue_spsc_isr_small.cpp
	test_queue_spsc_locked.cpp
	test_queue_spsc_locked_small.cpp
	test_random.cpp
	test_ratio.cpp
	test_reference_flat_map.cpp
	test_reference_flat_multimap.cpp
	test_reference_flat_multiset.cpp
	test_reference_flat_set.cpp
	test_rescale.cpp
	test_result.cpp
	test_rms.cpp
	test_scaled_rounding.cpp
	test_set.cpp
	test_shared_message.cpp
	test_singleton.cpp
	test_singleton_base.cpp
	test_smallest.cpp
	test_span_dynamic_extent.cpp
	test_span_fixed_extent.cpp
	test_stack.cpp
	test_standard_deviation.cpp
	test_state_chart.cpp
	test_state_chart_compile_time.cpp
	test_state_chart_compile_time_with_data_parameter.cpp
	test_state_chart_with_data_parameter.cpp
	test_state_chart_with_rvalue_data_parameter.cpp
	test_string_char.cpp
	test_string_char_external_buffer.cpp
	test_string_stream.cpp
	test_string_stream_u16.cpp
	test_string_stream_u32.cpp
	test_string_stream_u8.cpp
	test_string_stream_wchar_t.cpp
	test_string_u16.cpp
	test_string_u16_external_buffer.cpp
	test_string_u32.cpp
	test_string_u32_external_buffer.cpp
	test_string_u8.cpp
	test_string_u8_external_buffer.cpp
	test_string_utilities.cpp
	test_string_utilities_std.cpp
	test_string_utilities_std_u16.cpp
	test_string_utilities_std_u32.cpp
	test_string_utilities_std_u8.cpp
	test_string_utilities_std_wchar_t.cpp
	test_string_utilities_u16.cpp
	test_string_utilities_u32.cpp
	test_string_utilities_u8.cpp
	test_string_utilities_wchar_t.cpp
	test_string_view.cpp
	test_string_wchar_t.cpp
	test_string_wchar_t_external_buffer.cpp
	test_successor.cpp
	test_task_scheduler.cpp
	test_threshold.cpp
	test_to_arithmetic.cpp
	test_to_arithmetic_u16.cpp
	test_to_arithmetic_u32.cpp
	test_to_arithmetic_u8.cpp
	test_to_arithmetic_wchar_t.cpp
	test_to_string.cpp
	test_to_u16string.cpp
	test_to_u32string.cpp
	test_to_u8string.cpp
	test_to_wstring.cpp
	test_tuple.cpp
	test_type_def.cpp
	test_type_list.cpp
	test_type_lookup.cpp
	test_type_select.cpp
	test_type_traits.cpp
	test_unaligned_type.cpp
	test_unaligned_type_ext.cpp
	test_uncopyable.cpp
	test_unordered_map.cpp
	test_unordered_multimap.cpp
	test_unordered_multiset.cpp
	test_unordered_set.cpp
	test_user_type.cpp
	test_utility.cpp
	test_variance.cpp
	test_variant_legacy.cpp
	test_variant_pool.cpp
	test_variant_pool_external_buffer.cpp
	test_variant_variadic.cpp
	test_vector.cpp
	test_vector_external_buffer.cpp
	test_vector_non_trivial.cpp
	test_vector_pointer.cpp
	test_vector_pointer_external_buffer.cpp
	test_visitor.cpp
	test_xor_checksum.cpp
	test_xor_rotate_checksum.cpp
  )

target_compile_definitions(etl_tests PRIVATE -DETL_DEBUG)

option(ETL_NO_STL "No STL" OFF)

if (ETL_CXX_STANDARD MATCHES "98")
	message(STATUS "Compiling for C++98")
    set_property(TARGET etl_tests PROPERTY CXX_STANDARD 98)
elseif (ETL_CXX_STANDARD MATCHES "03")
	message(STATUS "Compiling for C++03 (C++98)")
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 98)
elseif (ETL_CXX_STANDARD MATCHES "11")
	message(STATUS "Compiling for C++11")
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 11)
elseif (ETL_CXX_STANDARD MATCHES "14")
	message(STATUS "Compiling for C++14")
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 14)
elseif (ETL_CXX_STANDARD MATCHES "17")
	message(STATUS "Compiling for C++17")
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 17)
elseif (ETL_CXX_STANDARD MATCHES "20")
	message(STATUS "Compiling for C++20")
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 20)
elseif (ETL_CXX_STANDARD MATCHES "23")
	message(STATUS "Compiling for C++23")
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 23)
else()
	message(STATUS "Unsupported C++ standard")
endif()

if (NO_STL OR ETL_NO_STL)
	message(STATUS "Compiling for No STL")
	target_compile_definitions(etl_tests PRIVATE -DETL_NO_STL)
else()
	message(STATUS "Compiling for STL")
endif()

if (ETL_USE_TYPE_TRAITS_BUILTINS)
	message(STATUS "Compiling for built-in type traits")
	target_compile_definitions(etl_tests PRIVATE -DETL_USE_TYPE_TRAITS_BUILTINS)
endif()

if (ETL_USER_DEFINED_TYPE_TRAITS)
	message(STATUS "Compiling for user defined type traits")
	target_compile_definitions(etl_tests PRIVATE -DETL_USER_DEFINED_TYPE_TRAITS)
endif()

if (ETL_MESSAGES_ARE_NOT_VIRTUAL)
	message(STATUS "Compiling for non-virtual messages")
	target_compile_definitions(etl_tests PRIVATE -DETL_MESSAGES_ARE_NOT_VIRTUAL)
endif()

if (ETL_FORCE_TEST_CPP03_IMPLEMENTATION)
	message(STATUS "Compiling for forced C++03 tests")
	target_compile_definitions(etl_tests PRIVATE -DETL_FORCE_TEST_CPP03_IMPLEMENTATION)
endif()

if (ETL_OPTIMISATION MATCHES "-O1")
	message(STATUS "Compiling with -O1 optimisations")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O1")
endif()

if (ETL_OPTIMISATION MATCHES "-O2")
	message(STATUS "Compiling with -O2 optimisations")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O2")
endif()

if (ETL_OPTIMISATION MATCHES "-O3")
	message(STATUS "Compiling with -O3 optimisations")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")
endif()

if ((CMAKE_CXX_COMPILER_ID MATCHES "MSVC"))
	message(STATUS "Using MSVC compiler")
	target_compile_options(etl_tests
			PRIVATE
			/Zc:__cplusplus
			)
endif ()

if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
	message(STATUS "Using GCC compiler")
endif ()

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    message(STATUS "Using Clang compiler")
endif ()

if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
	target_compile_options(etl_tests
			PRIVATE
			-fno-omit-frame-pointer
			-fno-common
			-Wall
			-Wextra
			-Werror
			-Wfloat-equal
			-Wshadow

=== zephyr/CMakeLists.txt ===
if(CONFIG_ETL)
  add_subdirectory(${CMAKE_CURRENT_LIST_DIR}/.. etl)
  zephyr_link_libraries(etl::etl)

  zephyr_compile_definitions_ifdef(CONFIG_ETL_DEBUG ETL_DEBUG)
  zephyr_compile_definitions_ifdef(CONFIG_ETL_CHECK_PUSH_POP ETL_CHECK_PUSH_POP)
  zephyr_compile_definitions_ifdef(CONFIG_ETL_LOG_ERRORS ETL_LOG_ERRORS)
endif()

=== examples/FunctionInterruptSimulation-Delegates/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)
project(FunctionInterruptSimulation)

add_definitions(-DETL_DEBUG)

include_directories(${UTPP_INCLUDE_DIRS} ${PROJECT_SOURCE_DIR}/../../include)

set(SOURCE_FILES FunctionInterruptSimulation.cpp)

add_executable(FunctionInterruptSimulation ${SOURCE_FILES})
target_include_directories(FunctionInterruptSimulation
  PUBLIC
  ${CMAKE_CURRENT_LIST_DIR}
  )

set_property(TARGET FunctionInterruptSimulation PROPERTY CXX_STANDARD 17)

=== examples/QueuedFSM/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)
project(queued_fsm)

add_definitions(-DETL_DEBUG)

include_directories(${UTPP_INCLUDE_DIRS} ${PROJECT_SOURCE_DIR}/../../include)

set(SOURCE_FILES QueuedFSM.cpp)

add_executable(queued_fsm ${SOURCE_FILES})
target_include_directories(queued_fsm
  PUBLIC
  ${CMAKE_CURRENT_LIST_DIR}
  )

set_property(TARGET queued_fsm PROPERTY CXX_STANDARD 17)

=== test/UnitTest++/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(UnitTestpp LANGUAGES CXX)

add_library(UnitTestpp
        AssertException.cpp
        Checks.cpp
        CompositeTestReporter.cpp
        CurrentTest.cpp
        DeferredTestReporter.cpp
        DeferredTestResult.cpp
        MemoryOutStream.cpp
        ReportAssert.cpp
        RequiredCheckException.cpp
        RequiredCheckTestReporter.cpp
        Test.cpp
        TestDetails.cpp
        TestList.cpp
        TestReporter.cpp
        TestReporterStdout.cpp
        TestResults.cpp
        TestRunner.cpp
        ThrowingTestReporter.cpp
        TimeConstraint.cpp
        XmlTestReporter.cpp
        )

target_include_directories(UnitTestpp SYSTEM INTERFACE ..)

if (WIN32)
    target_sources(UnitTestpp PRIVATE Win32/TimeHelpers.cpp)
else ()
    target_sources(UnitTestpp PRIVATE
            Posix/SignalTranslator.cpp
            Posix/TimeHelpers.cpp
            )
endif ()

if ((CMAKE_CXX_COMPILER_ID MATCHES "GNU") OR (CMAKE_CXX_COMPILER_ID MATCHES "Clang"))
    target_compile_options(UnitTestpp PRIVATE -fexceptions)
endif ()

if (UNIX AND NOT APPLE)
    # atomic is need on Linux with Clang
    set(THREADS_PREFER_PTHREAD_FLAG ON)
    find_package(Threads REQUIRED)
    target_link_libraries(UnitTestpp PRIVATE atomic Threads::Threads)
elseif (NOT UNIX AND APPLE)
    set(THREADS_PREFER_PTHREAD_FLAG ON)
    find_package(Threads REQUIRED)
    target_link_libraries(UnitTestpp PRIVATE Threads::Threads)
endif ()

=== test/etl_initializer_list/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)
project(etl_initializer_list_unit_tests)

add_definitions(-DETL_DEBUG)
add_definitions(-DETL_NO_STL)
add_definitions(-DETL_FORCE_ETL_INITIALIZER_LIST)

include_directories(${PROJECT_SOURCE_DIR}/../../include)

set(TEST_SOURCE_FILES
	test_initializer_list.cpp
  )

add_executable(etl_tests
  ${TEST_SOURCE_FILES}
  )

if (ETL_OPTIMISATION MATCHES "-O1")
  message(STATUS "Compiling with -O1 optimisations")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O1")
endif()

if (ETL_OPTIMISATION MATCHES "-O2")
  message(STATUS "Compiling with -O2 optimisations")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O2")
endif()

if (ETL_OPTIMISATION MATCHES "-O3")
  message(STATUS "Compiling with -O3 optimisations")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")
endif()

if (ETL_CXX_STANDARD MATCHES "98")
	message(STATUS "Compiling for C++98")
    set_property(TARGET etl_tests PROPERTY CXX_STANDARD 98)
elseif (ETL_CXX_STANDARD MATCHES "03")
	message(STATUS "Compiling for C++98")    
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 98)
elseif (ETL_CXX_STANDARD MATCHES "11")
	message(STATUS "Compiling for C++11")    
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 11)
elseif (ETL_CXX_STANDARD MATCHES "14")
	message(STATUS "Compiling for C++14")    
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 14)
elseif (ETL_CXX_STANDARD MATCHES "17")
	message(STATUS "Compiling for C++17")
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 17)
elseif (ETL_CXX_STANDARD MATCHES "20")
	message(STATUS "Compiling for C++20")
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 20)
else()
	message(STATUS "Compiling for C++23")
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 23)
endif()

target_include_directories(etl_tests
  PUBLIC
  ${CMAKE_CURRENT_LIST_DIR}
  )

if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
	message(STATUS "Using GCC compiler")
endif ()

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    message(STATUS "Using Clang compiler")
endif ()

if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
	target_compile_options(etl_tests
			PRIVATE
			-fno-omit-frame-pointer
			-fno-common
			-Wall
			-Wextra
			-Werror
			-Wfloat-equal
			-Wshadow
			-Wnull-dereference
			)
endif ()

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
	target_compile_options(etl_tests
			PRIVATE
			-fno-omit-frame-pointer
			-fno-common
			-Wall
			-Wextra
			-Werror
			-Wfloat-equal
			-Wshadow
			-Wnull-dereference
			)
endif ()

if ((CMAKE_CXX_COMPILER_ID MATCHES "GNU") OR (CMAKE_CXX_COMPILER_ID MATCHES "Clang"))
	if (ETL_ENABLE_SANITIZER MATCHES "ON")
		message(STATUS "Compiling with Sanitizer enabled")
		# MinGW doesn't presently support sanitization
		if (NOT MINGW)
			target_compile_options(etl_tests
				PRIVATE
				-fsanitize=address,undefined,bounds
				)

			target_link_options(etl_tests
				PRIVATE
				-fsanitize=address,undefined,bounds
				)	
		endif()
	endif ()
endif ()

# Enable the 'make test' CMake target using the executable defined above
add_test(etl_initializer_list_unit_tests etl_tests)

# Since ctest will only show you the results of the single executable
# define a target that will output all of the failing or passing tests
# as they appear from UnitTest++
add_custom_target(test_verbose COMMAND ${CMAKE_CTEST_COMMAND} --verbose)

=== test/etl_error_handler/assert_function/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)
project(etl_error_handler_unit_tests)

add_definitions(-DETL_DEBUG)
add_definitions(-DETL_USE_ASSERT_FUNCTION)
add_definitions(-DETL_VERBOSE_ERRORS)

include_directories(${PROJECT_SOURCE_DIR}/../../../include)

set(TEST_SOURCE_FILES
	assert_function.cpp
	test_error_handler.cpp
  )

add_executable(etl_tests
  ${TEST_SOURCE_FILES}
  )

if (ETL_CXX_STANDARD MATCHES "98")
	message(STATUS "Compiling for C++98")
    set_property(TARGET etl_tests PROPERTY CXX_STANDARD 98)
elseif (ETL_CXX_STANDARD MATCHES "03")
	message(STATUS "Compiling for C++98")    
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 98)
elseif (ETL_CXX_STANDARD MATCHES "11")
	message(STATUS "Compiling for C++11")    
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 11)
elseif (ETL_CXX_STANDARD MATCHES "14")
	message(STATUS "Compiling for C++14")    
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 14)
elseif (ETL_CXX_STANDARD MATCHES "17")
	message(STATUS "Compiling for C++17")    
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 17)
elseif (ETL_CXX_STANDARD MATCHES "20")
	message(STATUS "Compiling for C++20")
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 20)
else()
	message(STATUS "Compiling for C++23")
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 23)
endif()

if (ETL_OPTIMISATION MATCHES "-O1")
  message(STATUS "Compiling with -O1 optimisations")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O1")
endif()

if (ETL_OPTIMISATION MATCHES "-O2")
  message(STATUS "Compiling with -O2 optimisations")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O2")
endif()

if (ETL_OPTIMISATION MATCHES "-O3")
  message(STATUS "Compiling with -O3 optimisations")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")
endif()

target_include_directories(etl_tests
  PUBLIC
  ${CMAKE_CURRENT_LIST_DIR}
  )

if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
	message(STATUS "Using GCC compiler")
endif ()

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    message(STATUS "Using Clang compiler")
endif ()

if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
	target_compile_options(etl_tests
			PRIVATE
			-fno-omit-frame-pointer
			-fno-common
			-Wno-deprecated-declarations
			-Wall
			-Wextra
			-Werror
			-Wfloat-equal
			-Wshadow
			-Wnull-dereference
			)
endif ()

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
	target_compile_options(etl_tests
			PRIVATE
			-fno-omit-frame-pointer
			-fno-common
			-Wno-deprecated-declarations
			-Wall
			-Wextra
			-Werror
			-Wfloat-equal
			-Wshadow
			-Wnull-dereference
			)
endif ()

if ((CMAKE_CXX_COMPILER_ID MATCHES "GNU") OR (CMAKE_CXX_COMPILER_ID MATCHES "Clang"))
	if (ETL_ENABLE_SANITIZER MATCHES "ON")
		message(STATUS "Compiling with Sanitizer enabled")
		# MinGW doesn't presently support sanitization
		if (NOT MINGW)
			target_compile_options(etl_tests
				PRIVATE
				-fsanitize=address,undefined,bounds
				)

			target_link_options(etl_tests
				PRIVATE
				-fsanitize=address,undefined,bounds
				)	
		endif()
	endif ()
endif ()

# Enable the 'make test' CMake target using the executable defined above
add_test(etl_error_handler_unit_tests etl_tests)

# Since ctest will only show you the results of the single executable
# define a target that will output all of the failing or passing tests
# as they appear from UnitTest++
add_custom_target(test_verbose COMMAND ${CMAKE_CTEST_COMMAND} --verbose)

=== test/etl_error_handler/exceptions/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)
project(etl_error_handler_unit_tests)

add_definitions(-DETL_DEBUG)
add_definitions(-DETL_THROW_EXCEPTIONS)

include_directories(${PROJECT_SOURCE_DIR}/../../../include)

set(TEST_SOURCE_FILES
	test_error_handler.cpp
  )

add_executable(etl_tests
  ${TEST_SOURCE_FILES}
  )

if (ETL_CXX_STANDARD MATCHES "98")
	message(STATUS "Compiling for C++98")
    set_property(TARGET etl_tests PROPERTY CXX_STANDARD 98)
elseif (ETL_CXX_STANDARD MATCHES "03")
	message(STATUS "Compiling for C++98")    
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 98)
elseif (ETL_CXX_STANDARD MATCHES "11")
	message(STATUS "Compiling for C++11")    
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 11)
elseif (ETL_CXX_STANDARD MATCHES "14")
	message(STATUS "Compiling for C++14")    
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 14)
elseif (ETL_CXX_STANDARD MATCHES "17")
	message(STATUS "Compiling for C++17")    
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 17)
elseif (ETL_CXX_STANDARD MATCHES "20")
	message(STATUS "Compiling for C++20")
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 20)
else()
	message(STATUS "Compiling for C++23")
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 23)
endif()

if (ETL_OPTIMISATION MATCHES "-O1")
  message(STATUS "Compiling with -O1 optimisations")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O1")
endif()

if (ETL_OPTIMISATION MATCHES "-O2")
  message(STATUS "Compiling with -O2 optimisations")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O2")
endif()

if (ETL_OPTIMISATION MATCHES "-O3")
  message(STATUS "Compiling with -O3 optimisations")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")
endif()

target_include_directories(etl_tests
  PUBLIC
  ${CMAKE_CURRENT_LIST_DIR}
  )

if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
	message(STATUS "Using GCC compiler")
endif ()

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    message(STATUS "Using Clang compiler")
endif ()

if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
	target_compile_options(etl_tests
			PRIVATE
			-fno-omit-frame-pointer
			-fno-common
			-Wall
			-Wextra
			-Werror
			-Wfloat-equal
			-Wshadow
			-Wnull-dereference
			)
endif ()

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
	target_compile_options(etl_tests
			PRIVATE
			-fno-omit-frame-pointer
			-fno-common
			-Wall
			-Wextra
			-Werror
			-Wfloat-equal
			-Wshadow
			-Wnull-dereference
			)
endif ()

if ((CMAKE_CXX_COMPILER_ID MATCHES "GNU") OR (CMAKE_CXX_COMPILER_ID MATCHES "Clang"))
	if (ETL_ENABLE_SANITIZER MATCHES "ON")
		message(STATUS "Compiling with Sanitizer enabled")
		# MinGW doesn't presently support sanitization
		if (NOT MINGW)
			target_compile_options(etl_tests
				PRIVATE
				-fsanitize=address,undefined,bounds
				)

			target_link_options(etl_tests
				PRIVATE
				-fsanitize=address,undefined,bounds
				)	
		endif()
	endif ()
endif ()

# Enable the 'make test' CMake target using the executable defined above
add_test(etl_error_handler_unit_tests etl_tests)

# Since ctest will only show you the results of the single executable
# define a target that will output all of the failing or passing tests
# as they appear from UnitTest++
add_custom_target(test_verbose COMMAND ${CMAKE_CTEST_COMMAND} --verbose)

=== test/etl_error_handler/log_errors/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)
project(etl_error_handler_unit_tests)

add_definitions(-DETL_DEBUG)
add_definitions(-DETL_LOG_ERRORS)

include_directories(${PROJECT_SOURCE_DIR}/../../../include)

set(TEST_SOURCE_FILES
	test_error_handler.cpp
  )

add_executable(etl_tests
  ${TEST_SOURCE_FILES}
  )

if (ETL_CXX_STANDARD MATCHES "98")
	message(STATUS "Compiling for C++98")
    set_property(TARGET etl_tests PROPERTY CXX_STANDARD 98)
elseif (ETL_CXX_STANDARD MATCHES "03")
	message(STATUS "Compiling for C++98")    
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 98)
elseif (ETL_CXX_STANDARD MATCHES "11")
	message(STATUS "Compiling for C++11")    
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 11)
elseif (ETL_CXX_STANDARD MATCHES "14")
	message(STATUS "Compiling for C++14")    
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 14)
elseif (ETL_CXX_STANDARD MATCHES "17")
	message(STATUS "Compiling for C++17")
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 17)
elseif (ETL_CXX_STANDARD MATCHES "20")
	message(STATUS "Compiling for C++20")
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 20)
else()
	message(STATUS "Compiling for C++23")
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 23)
endif()

if (ETL_OPTIMISATION MATCHES "-O1")
  message(STATUS "Compiling with -O1 optimisations")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O1")
endif()

if (ETL_OPTIMISATION MATCHES "-O2")
  message(STATUS "Compiling with -O2 optimisations")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O2")
endif()

if (ETL_OPTIMISATION MATCHES "-O3")
  message(STATUS "Compiling with -O3 optimisations")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")
endif()

target_include_directories(etl_tests
  PUBLIC
  ${CMAKE_CURRENT_LIST_DIR}
  )

if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
	message(STATUS "Using GCC compiler")
endif ()

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    message(STATUS "Using Clang compiler")
endif ()

if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
	target_compile_options(etl_tests
			PRIVATE
			-fno-omit-frame-pointer
			-fno-common
			-fno-exceptions
			-Wall
			-Wextra
			-Werror
			-Wfloat-equal
			-Wshadow
			-Wnull-dereference
			)
endif ()

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
	target_compile_options(etl_tests
			PRIVATE
			-fno-omit-frame-pointer
			-fno-common
			-fno-exceptions
			-Wall
			-Wextra
			-Werror
			-Wfloat-equal
			-Wshadow
			-Wnull-dereference
			)
endif ()

if ((CMAKE_CXX_COMPILER_ID MATCHES "GNU") OR (CMAKE_CXX_COMPILER_ID MATCHES "Clang"))
	if (ETL_ENABLE_SANITIZER MATCHES "ON")
		message(STATUS "Compiling with Sanitizer enabled")
		# MinGW doesn't presently support sanitization
		if (NOT MINGW)
			target_compile_options(etl_tests
				PRIVATE
				-fsanitize=address,undefined,bounds
				)

			target_link_options(etl_tests
				PRIVATE
				-fsanitize=address,undefined,bounds
				)	
		endif()
	endif ()
endif ()

# Enable the 'make test' CMake target using the executable defined above
add_test(etl_error_handler_unit_tests etl_tests)

# Since ctest will only show you the results of the single executable
# define a target that will output all of the failing or passing tests
# as they appear from UnitTest++
add_custom_target(test_verbose COMMAND ${CMAKE_CTEST_COMMAND} --verbose)


#RSG
set_property(TARGET etl_tests PROPERTY CXX_STANDARD 17)

=== test/etl_error_handler/log_errors_and_exceptions/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)
project(etl_error_handler_unit_tests)

add_definitions(-DETL_DEBUG)
add_definitions(-DETL_THROW_EXCEPTIONS)
add_definitions(-DETL_LOG_ERRORS)

include_directories(${PROJECT_SOURCE_DIR}/../../../include)

set(TEST_SOURCE_FILES
	test_error_handler.cpp
  )

add_executable(etl_tests
  ${TEST_SOURCE_FILES}
  )

if (ETL_CXX_STANDARD MATCHES "98")
	message(STATUS "Compiling for C++98")
    set_property(TARGET etl_tests PROPERTY CXX_STANDARD 98)
elseif (ETL_CXX_STANDARD MATCHES "03")
	message(STATUS "Compiling for C++98")    
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 98)
elseif (ETL_CXX_STANDARD MATCHES "11")
	message(STATUS "Compiling for C++11")    
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 11)
elseif (ETL_CXX_STANDARD MATCHES "14")
	message(STATUS "Compiling for C++14")    
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 14)
elseif (ETL_CXX_STANDARD MATCHES "17")
	message(STATUS "Compiling for C++17")
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 17)
elseif (ETL_CXX_STANDARD MATCHES "20")
	message(STATUS "Compiling for C++20")
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 20)
else()
	message(STATUS "Compiling for C++23")
	set_property(TARGET etl_tests PROPERTY CXX_STANDARD 23)
endif()

if (ETL_OPTIMISATION MATCHES "-O1")
  message(STATUS "Compiling with -O1 optimisations")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O1")
endif()

if (ETL_OPTIMISATION MATCHES "-O2")
  message(STATUS "Compiling with -O2 optimisations")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O2")
endif()

if (ETL_OPTIMISATION MATCHES "-O3")
  message(STATUS "Compiling with -O3 optimisations")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")
endif()

target_include_directories(etl_tests
  PUBLIC
  ${CMAKE_CURRENT_LIST_DIR}
  )

if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
	message(STATUS "Using GCC compiler")
endif ()

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    message(STATUS "Using Clang compiler")
endif ()

if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
	target_compile_options(etl_tests
			PRIVATE
			-fno-omit-frame-pointer
			-fno-common
			-Wall
			-Wextra
			-Werror
			-Wfloat-equal
			-Wshadow
			-Wnull-dereference
			)
endif ()

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
	target_compile_options(etl_tests
			PRIVATE
			-fno-omit-frame-pointer
			-fno-common
			-Wall
			-Wextra
			-Werror
			-Wfloat-equal
			-Wshadow
			-Wnull-dereference
			)
endif ()

if ((CMAKE_CXX_COMPILER_ID MATCHES "GNU") OR (CMAKE_CXX_COMPILER_ID MATCHES "Clang"))
	if (ETL_ENABLE_SANITIZER MATCHES "ON")
		message(STATUS "Compiling with Sanitizer enabled")
		# MinGW doesn't presently support sanitization
		if (NOT MINGW)
			target_compile_options(etl_tests
				PRIVATE
				-fsanitize=address,undefined,bounds
				)

			target_link_options(etl_tests
				PRIVATE
				-fsanitize=address,undefined,bounds
				)	
		endif()
	endif ()
endif ()

# Enable the 'make test' CMake target using the executable defined above
add_test(etl_error_handler_unit_tests etl_tests)

# Since ctest will only show you the results of the single executable
# define a target that will output all of the failing or passing tests
# as they appear from UnitTest++
add_custom_target(test_verbose COMMAND ${CMAKE_CTEST_COMMAND} --verbose)


#RSG
set_property(TARGET etl_tests PROPERTY CXX_STANDARD 17)

=== debian/changelog ===
etlcpp (20.42.2+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Fri, 15 Aug 2025 13:22:09 -0700

etlcpp (20.42.1+dfsg-1) experimental; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Thu, 17 Jul 2025 14:26:25 +0200

=== debian/control ===
Source: etlcpp
Section: devel
Priority: optional
Build-Depends: debhelper (>= 11),
               python3-cogapp,
               doxygen,
               cmake,
               python3
Maintainer: Dima Kogan <dkogan@debian.org>
Standards-Version: 4.1.3
Homepage: http://www.etlcpp.org
Vcs-Git: https://salsa.debian.org/debian/etlcpp.git
Vcs-Browser: https://salsa.debian.org/debian/etlcpp

Package: libetlcpp-dev
Section: libdevel
Architecture: all
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}
Recommends: libetlcpp-doc
Description: Embedded Template Library: a C++ library for embedded applications
 ETL design objective covers the following areas:
 .
 - Create a set of containers where the size or maximum size is determined at
   compile-time.
 - These containers should be largely equivalent to those supplied in the STL,
   with a compatible API.
 - Be compatible with C++98 but implement as many of the later C++11/14/17
   additions as possible.
 - Have deterministic behaviour.
 - Add other useful components that are not present in the standard library.
 - The embedded template library has been designed for lower resource embedded
   applications. It defines a set of containers, algorithms, and utilities, some
   of which emulate parts of the STL. There is no dynamic memory allocation.
 - The library makes no use of the heap. All the containers (apart from
   intrusive types) have a fixed capacity allowing all memory allocation to be
   determined at compile-time. The library is intended for any compiler that
   supports C++03 or greater.
 .
 Development files

Package: libetlcpp-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Embedded Template Library: a C++ library for embedded applications
 ETL design objective covers the following areas:
 .
 - Create a set of containers where the size or maximum size is determined at
   compile-time.
 - These containers should be largely equivalent to those supplied in the STL,
   with a compatible API.
 - Be compatible with C++98 but implement as many of the later C++11/14/17
   additions as possible.
 - Have deterministic behaviour.
 - Add other useful components that are not present in the standard library.
 - The embedded template library has been designed for lower resource embedded
   applications. It defines a set of containers, algorithms, and utilities, some
   of which emulate parts of the STL. There is no dynamic memory allocation.
 - The library makes no use of the heap. All the containers (apart from
   intrusive types) have a fixed capacity allowing all memory allocation to be
   determined at compile-time. The library is intended for any compiler that
   supports C++03 or greater.
 .
 Documentation

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# These reproduce the generated files removed from the sources. debian/copyright
# contains the list of the removed files. The commands to regenerate these are
# in the comment of each removed file in the upstream tree
override_dh_auto_build:
	cd include/etl/generators && sh generate.bat
	dh_auto_build

	$(if $(filter nodoc,$(DEB_BUILD_OPTIONS)),,doxygen Doxyfile)

%:
	dh $@ --buildsystem=cmake

override_dh_auto_install:
	dh_auto_install
	rm -rf debian/tmp/usr/include/etl/.vscode*

override_dh_auto_configure:
	dh_auto_configure -- \
                -DETL_VERSION=$(patsubst %+dfsg,%,$(DEB_VERSION_UPSTREAM)) \
                -DBUILD_TESTS=$(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),OFF,ON) \
                -DETL_ENABLE_SANITIZER=OFF \
                -DCMAKE_CXX_FLAGS="-Wno-aggressive-loop-optimizations -Wno-pessimizing-move" # for gcc-13 compat

=== debian/watch ===
version=4
opts=\
repacksuffix=+dfsg,\
dversionmangle=s/\+dfsg//g,\
repack,\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/etlcpp-$1\.tar\.gz/ \
 https://github.com/ETLCPP/etl/tags .*/(\d\S+)\.tar\.gz
